import * as figma from "../figma";
import { type Preferences } from "../preferences";
import { Signal } from "../signal";
export declare class FrameCanvas {
    #private;
    static get styles(): string;
    static DRAG_MODE_KEY: string;
    get container(): HTMLElement;
    constructor(preferences: Signal<Readonly<Preferences>>, selected: Signal<figma.Node | null>, container?: HTMLElement);
    /**
     * Render a Figma frame to a DOM element.
     *
     * @param nodes
     * @param renderedImages
     */
    render(nodes: readonly figma.Node[], renderedImages: Map<string, string>, backgroundColor?: figma.Color): void;
    /**
     * Clear the viewport.
     */
    clear(): void;
    /**
     * Reset the canvas state.
     * This method does not clear the canvas.
     */
    reset(): void;
    select(node: figma.Node | null): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
}
