export interface Preferences {
    /**
     * For future changes.
     */
    version: 1;
    /**
     * How many decimal places are shown?
     * NOTE: Some properties uses fixed decimal places.
     */
    decimalPlaces: number;
    viewportZoomSpeed: number;
    viewportPanSpeed: number;
    /**
     * What unit should be used in generated CSS code?
     */
    lengthUnit: "px" | "rem";
    rootFontSizeInPx: number;
    /**
     * How to display a color in generated CSS code?
     */
    cssColorNotation: "hex" | "rgb" | "hsl" | "color-srgb" | "display-p3" | "srgb-to-display-p3";
    enableColorPreview: boolean;
}
export declare const defaultPreferenecs: Readonly<Preferences>;
export declare function isEqual(a: Readonly<Preferences>, b: Readonly<Preferences>): boolean;
