declare const enum Types {
    Idle = 0,
    SetupError = 1,
    Loaded = 2,
    Canvas = 3,
    Info = 4,
    Preferences = 5
}
interface Idle {
    type: Types.Idle;
}
export declare const idle: Idle;
export declare function isIdle(state: State<unknown>): state is Idle;
interface SetupError {
    type: Types.SetupError;
    error: Error;
}
export declare function setupError(error: Error): SetupError;
export declare function isSetupError(state: State<unknown>): state is SetupError;
interface Loaded<T> {
    type: Types.Loaded;
    data: T;
}
export declare function loaded<T>(data: T): Loaded<T>;
export declare function isLoaded<T>(state: State<T>): state is Loaded<T>;
export type State<T> = Idle | SetupError | Loaded<T>;
interface Canvas {
    type: Types.Canvas;
}
export declare const canvas: Canvas;
export declare function isCanvas(state: LoadedState): state is Canvas;
interface Info {
    type: Types.Info;
}
export declare const info: Info;
export declare function isInfo(state: LoadedState): state is Info;
interface Preferences {
    type: Types.Preferences;
}
export declare const preferences: Preferences;
export declare function isPreferences(state: LoadedState): state is Preferences;
export type LoadedState = Canvas | Info | Preferences;
export {};
