/**
 * @returns Angle in degrees
 */
export function getLinearGradientAngle(start, end) {
    return radToDeg(getAngle(start, end));
}
/**
 * Get angle of the vector in radian
 * @returns Angle in radian
 */
function getAngle(start, end) {
    return Math.atan(((end.y - start.y) / (end.x - start.x)) * -1);
}
export function radToDeg(rad) {
    const deg = ((180 * rad) / Math.PI) | 0;
    return deg < 0 ? 360 + deg : deg;
}
