import { el } from "../../dom";
import { Signal } from "../../signal";
export declare const styles = "\n  .pp-choice-container {\n    position: relative;\n  }\n\n  .pp-choice-input {\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 1px;\n    height: 1px;\n\n    opacity: 0;\n  }\n\n  .pp-choice-box {\n    padding: var(--action-vertical-padding) var(--action-horizontal-padding);\n    display: grid;\n    grid-template-columns: min-content minmax(0, 1fr);\n    grid-template-rows: max-content max-content;\n    align-items: center;\n    gap: var(--spacing_-2) var(--spacing_-1);\n    border: 1px solid var(--action-border);\n    border: 1px solid transparent;\n\n    border-radius: var(--action-radius);\n    cursor: pointer;\n  }\n  .pp-choice-input:checked + .pp-choice-box {\n    border-color: var(--action-border);\n  }\n  .pp-choice-input:checked + .pp-choice-box > .pp-choice-check {\n    color: var(--success-fg);\n\n    opacity: 1;\n  }\n  .pp-choice-input:focus-visible + .pp-choice-box {\n    box-shadow: 0 0 0 1px inset SelectedItem;\n    border-color: SelectedItem;\n  }\n  .pp-choice-box:hover {\n    background-color: var(--action-overlay);\n  }\n\n  .pp-choice-check {\n    height: calc(var(--font-size) * 0.8);\n    width: auto;\n\n    color: var(--subtle-fg);\n\n    opacity: 0.15;\n  }\n\n  .pp-choice-label {\n    font-size: calc(var(--font-size) * 1);\n\n    color: var(--fg);\n  }\n\n  .pp-choice-desc {\n    grid-column: 1 / 3;\n    margin: 0;\n    font-size: calc(var(--font-size) * 0.8);\n\n    color: var(--subtle-fg);\n  }\n";
type ElementChildren = NonNullable<Parameters<typeof el>[2]>;
interface ChoiceProps<T extends string> {
    value: T;
    label: ElementChildren[number];
    description?: ElementChildren;
    selected: Signal<T>;
    group: string;
    onChange(value: T): void;
}
export declare function choice<T extends string>({ value, label, description, selected, group, onChange, }: ChoiceProps<T>): HTMLElement;
export {};
