import { type ElementFn } from "../../dom";
import { Signal } from "../../signal";
export declare const styles = "\n  .sl-wrapper {\n    --_caret-size: calc(var(--font-size) * 0.625);\n    --_caret-width: calc(var(--_caret-size) * 0.8);\n\n    position: relative;\n    display: inline-flex;\n    box-sizing: border-box;\n  }\n\n  .sl-select {\n    appearance: none;\n    padding: var(--action-vertical-padding) var(--action-horizontal-padding);\n    padding-right: calc(var(--action-horizontal-padding) * 2 + var(--_caret-size));\n    margin: 0;\n    border: 1px solid var(--action-border);\n    border: none;\n    box-sizing: border-box;\n    font-size: calc(var(--font-size) * 0.8);\n    width: 100%;\n\n    background: transparent;\n    border-radius: var(--action-radius);\n    color: inherit;\n    cursor: pointer;\n    outline: none;\n  }\n  .sl-select:hover {\n    background-color: var(--action-overlay);\n  }\n  .sl-select:focus {\n    outline: none;\n  }\n  .sl-select:focus-visible {\n    outline: 2px solid SelectedItem;\n  }\n\n  .sl-caret {\n    position: absolute;\n    right: var(--action-horizontal-padding);\n    width: var(--_caret-size);\n    height: var(--_caret-size);\n    top: 0;\n    bottom: 0;\n    margin: auto 0;\n\n    pointer-events: none;\n    stroke: currentColor;\n    stroke-width: var(--_caret-width);\n    fill: none;\n  }\n";
interface SelectboxProps {
    attrs?: readonly ElementFn<HTMLSelectElement>[];
    options: readonly HTMLOptionElement[];
    wrapperAttrs?: readonly ElementFn<HTMLElement>[];
    value: string | undefined | Signal<string | undefined>;
    onChange?(value: string): void;
}
export declare function selectBox({ options, attrs, wrapperAttrs, value, onChange, }: SelectboxProps): HTMLElement;
export {};
