import { el, type ElementFn } from "../../dom";
import { type Signal } from "../../signal";
export declare const styles = "\n  .sn-container {\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n\n    overflow: hidden;\n    pointer-events: none;\n  }\n\n  @keyframes slidein {\n    0% {\n      opacity: 0;\n      transform: translateY(30%);\n    }\n\n    70% {\n      opacity: 1;\n    }\n\n    100% {\n      transform: translateY(0px);\n    }\n  }\n\n  @keyframes fadein {\n    from {\n      opacity: 0;\n    }\n\n    to {\n      opacity: 1;\n    }\n  }\n\n  .sn-wrapper {\n    position: absolute;\n    right: 0;\n    bottom: 0;\n    left: 0;\n    padding: var(--snackbar-margin);\n    min-width: 0;\n    width: 100%;\n    display: inline-flex;\n    justify-content: center;\n    align-items: center;\n  }\n\n  .sn-bar {\n    margin: 0;\n    min-width: 0;\n    display: inline-block;\n    padding: var(--snackbar-padding);\n    font-family: var(--snackbar-font-family);\n    font-size: var(--snackbar-font-size);\n    border: var(--snackbar-border);\n    box-sizing: border-box;\n\n    background-color: var(--snackbar-bg);\n    border-radius: var(--snackbar-radius);\n    box-shadow: var(--snackbar-shadow);\n    color: var(--snackbar-fg);\n    pointer-events: all;\n    z-index: calc(var(--z-index) + 11);\n\n    animation: 0.15s ease-in 0s 1 forwards slidein;\n  }\n\n  @media (prefers-reduced-motion: reduce) {\n    .sn-bar {\n      animation-name: fadein;\n    }\n  }\n";
export type SnackbarContent = NonNullable<Parameters<typeof el>[2]> | null;
interface SnackbarProps {
    signal: Signal<SnackbarContent>;
    lifetimeMs: number;
    attrs?: readonly ElementFn<HTMLDivElement>[];
}
export declare function snackbar({ signal, lifetimeMs, attrs, }: SnackbarProps): HTMLDivElement;
export {};
