import { type Preferences } from "../../preferences";
import { type CSSStyle } from "./cssgen/cssgen";
export declare const styles = "\n  .cc-container {\n    margin: 0;\n    padding: var(--spacing_-1);\n\n    background: var(--code-bg);\n    border-radius: var(--panel-radii);\n    color: var(--code-text);\n    overflow: auto;\n    user-select: text;\n  }\n\n  .cc-code {\n    font-family: var(--font-family-mono);\n    font-size: calc(var(--font-size) * 0.8);\n  }\n\n  .cc-color-preview {\n    --_size: calc(var(--font-size) * 0.8);\n\n    position: relative;\n    display: inline-flex;\n    width: var(--_size);\n    height: var(--_size);\n    border-radius: calc(var(--_size) / 6);\n    margin: 0 var(--spacing_-5);\n\n    background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 10 10\"><rect x=\"0\" y=\"0\" width=\"10\" height=\"10\" fill=\"%23fff\" /><rect x=\"5\" y=\"0\" width=\"5\" height=\"5\" fill=\"%23ccc\" /><rect x=\"0\" y=\"5\" width=\"5\" height=\"5\" fill=\"%23ccc\" /></svg>');\n    overflow: hidden;\n    vertical-align: middle;\n  }\n  .cc-color-preview::after {\n    content: \"\";\n    display: block;\n    position: absolute;\n    top: 0;\n    right: 0;\n    bottom: 0;\n    left: 0;\n    border: 1px solid rgb(var(--color-gray-5) / 0.7);\n\n    background: var(--_bg, transparent);\n    border-radius: inherit;\n  }\n\n  .cc-token-string {\n    color: var(--code-string);\n  }\n\n  .cc-token-number {\n    color: var(--code-number);\n  }\n\n  .cc-token-comment {\n    color: var(--code-comment);\n    font-style: italic;\n  }\n\n  .cc-token-keyword {\n    color: var(--code-keyword);\n  }\n\n  .cc-token-list {\n    color: var(--code-list);\n  }\n\n  .cc-token-function {\n    color: var(--code-function);\n  }\n\n  .cc-token-unit {\n    color: var(--code-unit);\n  }\n";
export declare function cssCode(styles: readonly CSSStyle[], preferences: Readonly<Preferences>): HTMLElement;
